"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
const child_process_1 = require("child_process");
const sessions_1 = require("../../help/sessions");
const treatment_1 = __importDefault(require("../../help/treatment"));
exports.init = new (class InicializePost {
    constructor() {
        this.child = '';
        this.res = '';
        this.option = '';
    }
    async StartSession(req, res, option) {
        var _a;
        const body = req.body;
        const reHttp = /^https?:/;
        const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
        this.res = res;
        this.option = option;
        if (option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.erro) {
                return res.send(user);
            }
        }
        if (body.url && body.url.length && !reHttp.test(body.url)) {
            res.sender({ erro: true, text: 'Error http webHook' });
            return;
        }
        const session = await sessions_1.sessionClient.newSession($_HEADERS_USER);
        if (session) {
            option.session = $_HEADERS_USER;
            option.url = body.url;
            const spawnArgs = [
                __dirname + '../../../services/hydra.js',
                JSON.stringify(option),
            ];
            this.child = (0, child_process_1.spawn)('node', spawnArgs, {
                stdio: ['inherit', 'inherit', 'inherit', 'ipc'],
            });
            this.child.on('message', async (response) => {
                if (response.connect) {
                    await sessions_1.sessionClient.addInfoSession(response.session, {
                        connect: response.connect,
                    });
                }
                if (response.delsession) {
                    await sessions_1.sessionClient.deleteSession(response.session);
                }
            });
            this.child.on('disconnect', (err) => {
                console.log('disconnect', err ? err : '');
            });
            this.child.on('error', async (err) => {
                if (err) {
                    console.log('on error', err);
                }
            });
            this.child.on('close', async (code) => {
                console.log(`child process exited with code`, code);
            });
            this.child.on('uncaughtException', (err) => {
                console.log(err);
            });
            sessions_1.sessionClient.addInfoSession($_HEADERS_USER, { child: this.child });
            res.send({ erro: false, text: 'Wait for connection' });
        }
        else {
            const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
            const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
            if (typeof getId === 'number') {
                const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                if (check && client) {
                    res.send({ erro: false, text: 'Successfully connected!' });
                }
                else {
                    res.send({ erro: false, text: 'Wait for connection' });
                }
            }
        }
    }
    async sendtext(req, res) {
        var _a;
        const body = req.body;
        const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
        this.res = res;
        if (this.option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.erro) {
                return res.send(user);
            }
        }
        if (!!body.to && body.to.length && !!body.body && body.body.length) {
            const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
            if (check) {
                const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                if (typeof getId === 'number') {
                    const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                    if (client) {
                        const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                        getUser.child.send(Object.assign({ type: 'sendText' }, body));
                        this.child.on('message', (response) => {
                            if (response.result) {
                                return res.send(response);
                            }
                        });
                    }
                }
            }
            else {
                res.send({
                    erro: true,
                    text: 'Not connected',
                });
            }
        }
        else {
            res.send({
                erro: true,
                text: 'The parameters are missing',
            });
        }
    }
    async sendFile(req, res) {
        var _a;
        const body = req.body;
        const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
        if (this.option.authentication) {
            const user = await treatment_1.default.CheckUserLogin(req);
            if (user.erro) {
                return res.send(user);
            }
        }
        if (!!body.to &&
            body.to.length &&
            !!body.file_path &&
            body.file_path.length &&
            !!body.file_name &&
            body.file_name.length) {
            const check = await sessions_1.sessionClient.checkClient($_HEADERS_USER);
            if (check) {
                const getId = await sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                if (typeof getId === 'number') {
                    const client = await sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                    if (client) {
                        const getUser = await sessions_1.sessionClient.getUser($_HEADERS_USER);
                        getUser.child.send(Object.assign({ type: 'sendFile' }, body));
                        this.child.on('message', (response) => {
                            if (response.result) {
                                return res.send(response);
                            }
                        });
                    }
                }
            }
            else {
                res.send({
                    erro: true,
                    text: 'Not connected',
                });
            }
        }
        else {
            res.send({
                erro: true,
                text: 'The parameters are missing',
            });
        }
    }
})();
//# sourceMappingURL=post.js.map